<script lang="ts">
  import type { Team } from '@models/Team';
  import { KeycloakStore, KeycloakInterface } from '@auth/keycloak';
  import type { ActiveChallenge, ActiveChallengeReturn } from '@models/Challenges';
  import { Gql } from '../../db';
  import { Badge, Card, CardBody, CardTitle } from 'sveltestrap';
  import type { NullableEventRole } from '@auth/models';
  import ChallengeModal from '@components/Challenges/ChallengeModal.svelte';
  import { onMount } from 'svelte';
  import Env from '../../env';

  let keycloak: KeycloakInterface | undefined;
  let team: Team | undefined;
  let challenges: ActiveChallenge[] = [];
  let categories: Array<string>;
  let challengeModal: ChallengeModal;
  let queryRole: NullableEventRole = null;

  $: if (challenges) categories = [...new Set(challenges.map((c) => c.challenge!.category))];

  KeycloakStore.subscribe(async (value) => {
    keycloak = value.keycloak;
    team = value.team;
    queryRole = keycloak?.getHighestPrivilegeRole();
  });

  const challengeSink = {
    complete: () => console.warn('subscription complete'),
    error: (err) => console.error(err),
    next: (res: { data: ActiveChallengeReturn }) => {
      challenges = res.data.challenges_active;
    },
  };

  onMount(() => {
    // only query for solves if we're not on a team (eg, solves query would fail for staff)
    const solvesQuery = `
        solves(where: {team_id: {_eq: ${JSON.stringify(team?.id)}}}) {
          challenge_id
          time
          team_id
        }`;
    const query = `subscription {
      challenges_active (where: {event_id: {_eq: ${JSON.stringify(keycloak?.eventID || Env.EventID)}}}) {
        points
        release_time
        released
        event_id
        challenge_id
        event {
          id
          name
          start
          end
        }
        files {
          file_id
          event_id
          file {
            id
            name
            size
            mimeType
          }
        }
        challenge {
          category
          description
          designer
          id
          name
        }
        ${team ? solvesQuery : ''}
      }
    }`;
    Gql.subscribe(query, challengeSink, { role: queryRole });
  });
</script>

<ChallengeModal bind:this={challengeModal} bind:team bind:queryRole size="lg" />

{#if challenges?.length > 0 && categories?.length > 0}
  {#each categories as challengeCategory}
    <h2 class="category-header mt-3">{challengeCategory}</h2>
    <div class="row row-cols-xs-1 row-cols-sm-2 row-cols-md-3 row-cols-xxl-5">
      {#each challenges as challenge}
        {#if challenge.challenge.category === challengeCategory}
          <div class="col p-2">
            <Card class="h-100 clickable" on:click={() => challengeModal.show(challenge)}>
              <CardTitle class="text-center {challenge.solves?.length > 0 ? 'bg-success' : 'bg-secondary'}">
                <p class="fs-3">
                  {challenge.challenge.name}
                </p>
                {#if !challenge.released}
                  <!-- Staff may view challenges not yet released -->
                  <small><Badge pill color="warning">Unreleased</Badge></small>
                {/if}
                <br />
                {#if challenge.challenge.designer}
                  <small class="fs-6">
                    by: {challenge.challenge.designer}
                  </small>
                {/if}
              </CardTitle>
              <CardBody>
                <h3 class="d-flex align-content-center justify-content-center text-white">
                  {challenge.points}
                </h3>
              </CardBody>
            </Card>
          </div>
        {/if}
      {/each}
    </div>
  {/each}
{/if}

<style>
  .category-header {
    border-bottom: 1px solid var(--bs-light);
  }
</style>
